C	*************************************************************
C	ROUTINES TO SIMULATE PGRAPH.LIB SIMILAR FUNCTIONS USING
C	THE MS-FORTRAN GRAPHICS LIBRARY
C	*************************************************************
	INCLUDE 'FGRAPH.FI'
C	*************************************************************
C	INITIALIZATION OF GRAPHICS SYSTEM
C	*************************************************************
	SUBROUTINE GRINIT(TYPE,XMIN,YMIN,XMAX,YMAX,KE)
	INTEGER TYPE,KE
	REAL XMIN,YMIN,XMAX,YMAX

	INCLUDE 'FGRAPH.FD'
	RECORD /VIDEOCONFIG/ SCREEN
	RECORD /RCCOORD/ CURPOS

	REAL XF,YF,XC,YC
	INTEGER*2 PX0,PXE,PY0,PYE,NUMX,NUMY,NUMCOLS,NUMROWS
	LOGICAL XLOG,YLOG
	COMMON /KSYSTEM/ XLOG,YLOG,XF,YF,XC,YC
	COMMON /CLIP/ PX0,PY0,PXE,PYE,NUMX,NUMY

	INTEGER*2 ERR,NX,NY,NDUMMY,IMIN,IMAX
	REAL XDMIN,XDMAX,YDMIN,YDMAX,XS,YS,X0,Y0,DEL,POT
	CHARACTER*8 ASTR,ZWRITE
	INTEGER ZFORM,NFORM

	INTEGER*2 STYLE(8)
	COMMON /LINES/ STYLE
	EXTERNAL LINESTYLE
	EXTERNAL SYMBMASK

	KE=0
	ERR=SETVIDEOMODE($MAXRESMODE)
	IF (ERR.EQ.0) GOTO 910
	CALL GETVIDEOCONFIG(SCREEN)
	NUMX=SCREEN.NUMXPIXELS
	NUMY=SCREEN.NUMYPIXELS
	NUMCOLS=SCREEN.NUMTEXTCOLS
	NUMROWS=SCREEN.NUMTEXTROWS
	PX0=8.5/NUMCOLS*NUMX
	PXE=(1.0-1.5/NUMCOLS)*NUMX
	PY0=(1.0-1.5/NUMROWS)*NUMY
	PYE=1.5/NUMROWS*NUMY
C	*************************************************************
C	PREFERENCES
C	*************************************************************
	ERR=SETBKCOLOR(INT2(0))
	ERR=SETCOLOR(INT2(15))
	ERR=SETTEXTCOLOR(INT2(15))
	CALL SETLINESTYLE(STYLE(1))
	CALL CLEARSCREEN(INT2(0))
	ERR=RECTANGLE($GBORDER,PX0,PYE,PXE,PY0)
C	*************************************************************
C	CHECK
C	*************************************************************
	XLOG=(MOD(TYPE,2).EQ.1)
	YLOG=(TYPE.GT.1)	
	IF (XMIN.GE.XMAX.OR.YMIN.GE.YMAX) GOTO 905
	IF (XLOG.AND.XMIN.LE.0.0) GOTO 905
	IF (YLOG.AND.YMIN.LE.0.0) GOTO 905
C	*************************************************************
C	CALCULATE USED MINIMA/MAXIMA
C	*************************************************************
	IF (XLOG) THEN
	XDMIN=10.0**NINT(ALOG10(XMIN)-0.4999)
	XDMAX=10.0**NINT(ALOG10(XMAX)+0.4999)
	ELSE
	XS=XMAX-XMIN
	DEL=XS/100.0
	POT=10.0**NINT(ALOG10(XS)-1.5)
	IMIN=NINT((XMIN-DEL)/POT-0.4999)
	IMAX=NINT((XMAX+DEL)/POT+0.4999)
 	XDMAX=IMAX*POT
 	XDMIN=IMIN*POT
	ENDIF
	IF (YLOG) THEN
	YDMIN=10.0**NINT(ALOG10(YMIN)-0.4999)
	YDMAX=10.0**NINT(ALOG10(YMAX)+0.4999)
	ELSE
	YS=YMAX-YMIN
	DEL=YS/100.0
	POT=10.0**NINT(ALOG10(YS)-1.5)
	IMIN=NINT((YMIN-DEL)/POT-0.4999)
	IMAX=NINT((YMAX+DEL)/POT+0.4999)
 	YDMAX=IMAX*POT
 	YDMIN=IMIN*POT
	ENDIF
C	*************************************************************
C	PARAMETER FOR COORD
C	*************************************************************
	IF (XLOG) THEN
	XF=(PXE-PX0)/(ALOG10(XDMAX)-ALOG10(XDMIN))
	XC=PX0-XF*ALOG10(XDMIN)
	ELSE
	XF=(PXE-PX0)/(XDMAX-XDMIN)
	XC=PX0-XF*XDMIN
	ENDIF
	IF (YLOG) THEN
	YF=(PYE-PY0)/(ALOG10(YDMAX)-ALOG10(YDMIN))
	YC=PY0-YF*ALOG10(YDMIN)
	ELSE
	YF=(PYE-PY0)/(YDMAX-YDMIN)
	YC=PY0-YF*YDMIN
	ENDIF
C	*************************************************************
C	ACHSBESCHRIFTUNGEN
C	*************************************************************
	CALL SETTEXTPOSITION(NUMROWS,INT2(9),CURPOS)
	NFORM=MIN(ZFORM(XDMIN),ZFORM(XDMAX))
	IF (XLOG) NFORM=MIN(NFORM,2)
	ASTR=ZWRITE(XDMIN,NFORM)
	CALL OUTTEXT(ASTR)
	CALL SETTEXTPOSITION(NUMROWS,INT2(NUMCOLS-8),CURPOS)
	ASTR=ZWRITE(XDMAX,NFORM)
	CALL OUTTEXT(ASTR)
	CALL SETTEXTPOSITION(INT2(NUMROWS-1),INT2(1),CURPOS)
	NFORM=MIN(ZFORM(YDMIN),ZFORM(YDMAX))
	IF (YLOG) NFORM=MIN(NFORM,2)
	ASTR=ZWRITE(YDMIN,NFORM)
	CALL OUTTEXT(ASTR)
	CALL SETTEXTPOSITION(INT2(2),INT2(1),CURPOS)
	ASTR=ZWRITE(YDMAX,NFORM)
	CALL OUTTEXT(ASTR)
C	*************************************************************
C	STRICHE IN X (UND RASTER)
C	*************************************************************
	IF (XLOG) THEN
	X0=XDMIN
310	DO 320 I=1,9
	XS=I*X0
	CALL COORD(XS,1.0,NX,NDUMMY)
	CALL SGLLINE(NX,PY0,NX,INT2(PY0-7))
	CALL SGLLINE(NX,PYE,NX,INT2(PYE+7))
320	CONTINUE	
	X0=X0*10.0
	IF (X0.LT.0.9*XDMAX) GOTO 310
	ELSE
	X0=(PXE-PX0)/10.0
	DO 300 I=1,9
	NX=PX0+I*X0
	CALL SGLLINE(NX,PY0,NX,INT2(PY0-7))
	CALL SGLLINE(NX,PYE,NX,INT2(PYE+7))
300	CONTINUE
	ENDIF
C	*************************************************************
C	STRICHE IN Y
C	*************************************************************
	IF (YLOG) THEN
	Y0=YDMIN
410	DO 420 I=1,9
	YS=I*Y0
	CALL COORD(1.0,YS,NDUMMY,NY)
	CALL SGLLINE(PX0,NY,INT2(PX0+7),NY)
	CALL SGLLINE(PXE,NY,INT2(PXE-7),NY)
420	CONTINUE	
	Y0=Y0*10.0
	IF (Y0.LT.0.9*YDMAX) GOTO 410
	ELSE
	YS=(PYE-PY0)/10.0
	DO 400 I=1,9
	NY=PY0+I*YS
	CALL SGLLINE(PX0,NY,INT2(PX0+7),NY)
	CALL SGLLINE(PXE,NY,INT2(PXE-7),NY)
400	CONTINUE
	ENDIF
	RETURN
C	*************************************************************
C	ERROR HANDLING
C	*************************************************************
905	ERR=SETVIDEOMODE($DEFAULTMODE)
10	FORMAT (' Graphics error occured !')
910	KE=1
	WRITE (6,10)
	RETURN
	END

C       *************************************************************
C       MAKE AXIS DESCRIPTIONS
C       *************************************************************
        SUBROUTINE GRAXIS(NUM,STRING)
        INTEGER NUM
        CHARACTER*(*) STRING
	INTEGER IROWA,ICOLA,IROWO,ICOLO,IROWH,ICOLH
	DATA ICOLA/40/,IROWA/30/,ICOLO/1/,IROWO/15/,ICOLH/12/,IROWH/1/

        IF (NUM.EQ.1) THEN
        CALL GRPRINT(IROWA,ICOLA,STRING)
        ELSE IF (NUM.EQ.2) THEN
        CALL GRPRINT(IROWO,ICOLO,STRING)
        ELSE
        CALL GRPRINT(IROWH,ICOLH,STRING)
        ENDIF
        RETURN
        END

C	*************************************************************
C	PRINT ON GRAPHICS SCREEN
C	*************************************************************
	SUBROUTINE GRPRINT(CX,CY,STRING)
	INTEGER CX,CY
	CHARACTER*(*) STRING
	INTEGER*2 NX,NY
	INCLUDE 'FGRAPH.FD'
	RECORD /RCCOORD/ CURPOS

	NX=CX
	NY=CY
	CALL SETTEXTPOSITION(NX,NY,CURPOS)
	CALL OUTTEXT(STRING)
	RETURN
	END

C	*************************************************************
C	DRAW GRAPH LINE
C	*************************************************************
	SUBROUTINE GRDRAW(NCOL,N,X,Y)
	REAL X(*),Y(*)
	INTEGER N,NCOL
	INCLUDE 'FGRAPH.FD'
	INTEGER*2 PX0,PXE,PY0,PYE,NUMX,NUMY,NX,NY,NUMBER,ERR
	INTEGER*2 STYLE(8)
	RECORD /XYCOORD/ XY
	COMMON /LINES/ STYLE
	COMMON /CLIP/ PX0,PY0,PXE,PYE,NUMX,NUMY

	NUMBER=NCOL
	CALL SETCLIPRGN(PX0,PYE,PXE,PY0)
	ERR=SETCOLOR(NUMBER)
	CALL SETLINESTYLE(STYLE(NUMBER))
	CALL COORD(X(1),Y(1),NX,NY)
	CALL MOVETO(NX,NY,XY)
	DO 100 I=2,N
	CALL COORD(X(I),Y(I),NX,NY)
100	ERR=LINETO(NX,NY)
	CALL SETCLIPRGN(INT2(0),INT2(0),INT2(NUMX-1),INT2(NUMY-1))
	RETURN
	END

C	*************************************************************
C	WAIT UNTIL KEYPRESSED
C	*************************************************************
	SUBROUTINE WAIT
	READ (5,*)
	RETURN
	END

C	*************************************************************
C	CLOSE GRAPHICS
C	*************************************************************
	SUBROUTINE GRCLOSE
	INCLUDE 'FGRAPH.FD'
	INTEGER*2 ERR
	ERR=SETVIDEOMODE($DEFAULTMODE)
	RETURN
	END

C	*************************************************************
C	KOORDINATENTRAFO
C	*************************************************************
	SUBROUTINE COORD(X,Y,NX,NY)
	REAL X,Y,XF,YF,XC,YC
	INTEGER*2 NX,NY
	LOGICAL XLOG,YLOG
	COMMON /KSYSTEM/ XLOG,YLOG,XF,YF,XC,YC

	IF(XLOG) THEN
	NX=NINT(XF*ALOG10(X)+XC)
	ELSE
	NX=NINT(XF*X+XC)
	ENDIF
	IF(YLOG) THEN
	NY=NINT(YF*ALOG10(Y)+YC)
	ELSE
	NY=NINT(YF*Y+YC)
	ENDIF
	RETURN
	END

C	*************************************************************
C	LINE WITH CURRENT STYLE
C	*************************************************************
	SUBROUTINE SGLLINE(AX,AY,BX,BY)
	INTEGER*2 AX,AY,BX,BY,ERR
	INCLUDE 'FGRAPH.FD'
	RECORD /XYCOORD/ XY

	CALL MOVETO(AX,AY,XY)
	ERR=LINETO(BX,BY)
	RETURN
	END

C	*************************************************************
C	ROUTINE TO SELECT THE MOST APPROPRIATE WRITING FORMAT
C	FOR A REAL NUMBER TO AN 8 BYTE STRING
C	*************************************************************
	INTEGER FUNCTION ZFORM(X)
	REAL X,BX

	BX=ABS(X)
	IF (BX.GT.9.999E9.OR.BX.LT.1E-9) THEN
	ZFORM=1
	ELSE IF (BX.GT.9999.0.OR.BX.LT.1E-3) THEN
	ZFORM=2
	ELSE IF (BX.GT.9.999) THEN
	ZFORM=3
	ELSE
	ZFORM=4
	ENDIF
	RETURN
	END

C	*************************************************************
C	ROUTINE TO WRITE A REAL NUMBER TO AN 8 BYTE STRING
C	ACCORDING TO THE GIVEN FORMAT NUMBER
C	(USE ONLY WITH ZFORM !)
C	*************************************************************
	CHARACTER*8 FUNCTION ZWRITE(X,N)
	REAL X
	INTEGER N,NPKT

	CHARACTER VORKOM
	CHARACTER*8 HELP1,HELP2
	CHARACTER*9 HELP3

	SELECT CASE(N)
	CASE(2)
	WRITE (ZWRITE,'(1P,E8.2E1)') X
	CASE(3)
	WRITE (ZWRITE,'(F8.2)') X
	CASE(4)
	WRITE (ZWRITE,'(F8.5)') X
	CASE DEFAULT
	WRITE (ZWRITE,'(1P,E8.1)') X
	END SELECT
C	*************************************************************
C	NULL VORS KOMMA, WENN NICHT VORHANDEN
C	*************************************************************
	NPKT=INDEX(ZWRITE,'.')-1
	VORKOM=ZWRITE(NPKT:NPKT)
	IF (VORKOM.EQ.' '.OR.VORKOM.EQ.'-') THEN
	HELP1=ZWRITE(1:NPKT)
	HELP2=ZWRITE(NPKT+1:)
	HELP3=HELP1(1:NPKT)//'0'//HELP2
	ZWRITE=HELP3(2:)
	ENDIF
	RETURN
	END

C	*************************************************************
C	DEFINITION OF THE LINE STYLES
C	*************************************************************
	BLOCK DATA LINESTYLE
	INTEGER*2 STYLE(8)
	COMMON /LINES/ STYLE

	DATA STYLE /-1,-21846,-13108,-3856,-256,-10571,-7740,
     % -3462/

	END

C       *************************************************************
C       MACHINE DEPENDENT PAUSE LOOP
C       *************************************************************
        SUBROUTINE SMLPAUSE
	INTEGER I
	REAL ERGO

	ERGO=1.0
	DO 200 I=1,120000
200	ERGO=SIN(I*ERGO/200.0)
        RETURN
        END

